Index: uspace/lib/drv/generic/driver.c
===================================================================
--- uspace/lib/drv/generic/driver.c	(revision 071a1ddbcc6bb2b9c6f3c1a3acc865f1f23b5fe0)
+++ uspace/lib/drv/generic/driver.c	(revision 25a179efc4ecca45aa90793992b6c1c2743fd07f)
@@ -199,5 +199,5 @@
 		dev_del_ref(dev);
 	
-	async_answer_0(iid, (sysarg_t) rc);
+	async_answer_0(iid, rc);
 }
 
@@ -227,5 +227,5 @@
 		dev_del_ref(dev);
 	
-	async_answer_0(iid, (sysarg_t) rc);
+	async_answer_0(iid, rc);
 }
 
@@ -262,5 +262,5 @@
 	fun_del_ref(fun);
 	
-	async_answer_0(iid, (sysarg_t) rc);
+	async_answer_0(iid, rc);
 }
 
@@ -295,5 +295,5 @@
 		rc = ENOTSUP;
 	
-	async_answer_0(iid, (sysarg_t) rc);
+	async_answer_0(iid, rc);
 }
 
Index: uspace/lib/drv/generic/remote_ahci.c
===================================================================
--- uspace/lib/drv/generic/remote_ahci.c	(revision 071a1ddbcc6bb2b9c6f3c1a3acc865f1f23b5fe0)
+++ uspace/lib/drv/generic/remote_ahci.c	(revision 25a179efc4ecca45aa90793992b6c1c2743fd07f)
@@ -95,5 +95,5 @@
 	async_data_read_start(exch, sata_dev_name, sata_dev_name_length);
 	
-	sysarg_t rc;
+	int rc;
 	async_wait_for(req, &rc);
 	
@@ -155,5 +155,5 @@
 	async_exchange_end(exch);
 	
-	sysarg_t rc;
+	int rc;
 	async_wait_for(req, &rc);
 	
@@ -175,5 +175,5 @@
 	async_exchange_end(exch);
 	
-	sysarg_t rc;
+	int rc;
 	async_wait_for(req, &rc);
 	
Index: uspace/lib/drv/generic/remote_ieee80211.c
===================================================================
--- uspace/lib/drv/generic/remote_ieee80211.c	(revision 071a1ddbcc6bb2b9c6f3c1a3acc865f1f23b5fe0)
+++ uspace/lib/drv/generic/remote_ieee80211.c	(revision 25a179efc4ecca45aa90793992b6c1c2743fd07f)
@@ -75,5 +75,5 @@
 	async_exchange_end(exch);
 	
-	sysarg_t res;
+	int res;
 	async_wait_for(aid, &res);
 	
@@ -130,5 +130,5 @@
 	assert(ssid_start);
 	
-	sysarg_t rc_orig;
+	int rc_orig;
 	
 	async_exch_t *exch = async_exchange_begin(dev_sess);
@@ -137,5 +137,5 @@
 	    IEEE80211_CONNECT, NULL);
 	
-	sysarg_t rc = async_data_write_start(exch, ssid_start,
+	int rc = async_data_write_start(exch, ssid_start,
 	    str_size(ssid_start) + 1);
 	if (rc != EOK) {
Index: uspace/lib/drv/generic/remote_nic.c
===================================================================
--- uspace/lib/drv/generic/remote_nic.c	(revision 071a1ddbcc6bb2b9c6f3c1a3acc865f1f23b5fe0)
+++ uspace/lib/drv/generic/remote_nic.c	(revision 25a179efc4ecca45aa90793992b6c1c2743fd07f)
@@ -105,5 +105,5 @@
 	aid_t req = async_send_1(exch, DEV_IFACE_ID(NIC_DEV_IFACE),
 	    NIC_SEND_MESSAGE, &answer);
-	sysarg_t retval = async_data_write_start(exch, data, size);
+	int retval = async_data_write_start(exch, data, size);
 	
 	async_exchange_end(exch);
@@ -131,5 +131,5 @@
 	ipc_call_t answer;
 	int rc;
-	sysarg_t retval;
+	int retval;
 	
 	async_exch_t *exch = async_exchange_begin(dev_sess);
@@ -147,5 +147,5 @@
 	
 	async_wait_for(req, &retval);
-	return (int) retval;
+	return retval;
 }
 
@@ -210,5 +210,5 @@
 	async_exchange_end(exch);
 	
-	sysarg_t res;
+	int res;
 	async_wait_for(aid, &res);
 	
@@ -237,5 +237,5 @@
 	async_exchange_end(exch);
 	
-	sysarg_t res;
+	int res;
 	async_wait_for(aid, &res);
 	
@@ -295,5 +295,5 @@
 	async_exchange_end(exch);
 
-	sysarg_t res;
+	int res;
 	async_wait_for(aid, &res);
 	
@@ -629,5 +629,5 @@
 	async_exchange_end(exch);
 	
-	sysarg_t res;
+	int res;
 	async_wait_for(message_id, &res);
 	
@@ -717,5 +717,5 @@
 	async_exchange_end(exch);
 	
-	sysarg_t res;
+	int res;
 	async_wait_for(message_id, &res);
 	
@@ -878,5 +878,5 @@
 	async_exchange_end(exch);
 	
-	sysarg_t res;
+	int res;
 	async_wait_for(message_id, &res);
 	
@@ -938,5 +938,5 @@
 	async_exchange_end(exch);
 	
-	sysarg_t res;
+	int res;
 	async_wait_for(message_id, &res);
 	
@@ -997,5 +997,5 @@
 	    NIC_WOL_VIRTUE_ADD, (sysarg_t) type, send_data, &result);
 	
-	sysarg_t res;
+	int res;
 	if (send_data) {
 		int rc = async_data_write_start(exch, data, length);
@@ -1311,5 +1311,5 @@
 	async_exchange_end(exch);
 	
-	sysarg_t res;
+	int res;
 	async_wait_for(message_id, &res);
 	
Index: uspace/lib/drv/generic/remote_usb.c
===================================================================
--- uspace/lib/drv/generic/remote_usb.c	(revision 071a1ddbcc6bb2b9c6f3c1a3acc865f1f23b5fe0)
+++ uspace/lib/drv/generic/remote_usb.c	(revision 25a179efc4ecca45aa90793992b6c1c2743fd07f)
@@ -233,6 +233,6 @@
 
 	/* Wait for the answer. */
-	sysarg_t data_request_rc;
-	sysarg_t opening_request_rc;
+	int data_request_rc;
+	int opening_request_rc;
 	async_wait_for(data_request, &data_request_rc);
 	async_wait_for(opening_request, &opening_request_rc);
@@ -281,5 +281,5 @@
 
 	/* Wait for the answer. */
-	sysarg_t opening_request_rc;
+	int opening_request_rc;
 	async_wait_for(opening_request, &opening_request_rc);
 
Index: uspace/lib/drv/generic/remote_usbhc.c
===================================================================
--- uspace/lib/drv/generic/remote_usbhc.c	(revision 071a1ddbcc6bb2b9c6f3c1a3acc865f1f23b5fe0)
+++ uspace/lib/drv/generic/remote_usbhc.c	(revision 25a179efc4ecca45aa90793992b6c1c2743fd07f)
@@ -131,6 +131,6 @@
 
 	/* Wait for the answer. */
-	sysarg_t data_request_rc;
-	sysarg_t opening_request_rc;
+	int data_request_rc;
+	int opening_request_rc;
 	async_wait_for(data_request, &data_request_rc);
 	async_wait_for(opening_request, &opening_request_rc);
@@ -182,5 +182,5 @@
 
 	/* Wait for the answer. */
-	sysarg_t opening_request_rc;
+	int opening_request_rc;
 	async_wait_for(opening_request, &opening_request_rc);
 
Index: uspace/lib/drv/generic/remote_usbhid.c
===================================================================
--- uspace/lib/drv/generic/remote_usbhid.c	(revision 071a1ddbcc6bb2b9c6f3c1a3acc865f1f23b5fe0)
+++ uspace/lib/drv/generic/remote_usbhid.c	(revision 25a179efc4ecca45aa90793992b6c1c2743fd07f)
@@ -174,6 +174,6 @@
 	}
 	
-	sysarg_t data_request_rc;
-	sysarg_t opening_request_rc;
+	int data_request_rc;
+	int opening_request_rc;
 	async_wait_for(data_request, &data_request_rc);
 	async_wait_for(opening_request, &opening_request_rc);
@@ -259,6 +259,6 @@
 	}
 	
-	sysarg_t data_request_rc;
-	sysarg_t opening_request_rc;
+	int data_request_rc;
+	int opening_request_rc;
 	async_wait_for(data_request, &data_request_rc);
 	async_wait_for(opening_request, &opening_request_rc);